Index: Configuration.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Configuration.cpp,v
retrieving revision 1.57
diff -u -p -b -r1.57 Configuration.cpp
--- Configuration.cpp	23 Jan 2005 00:23:45 -0000	1.57
+++ Configuration.cpp	10 Apr 2005 22:43:19 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-//  $Id: Configuration.cpp,v 1.57 2005/01/23 00:23:45 klas Exp $
+//  $Id: Configuration.cpp,v 1.96 2005/04/02 09:41:46 klas Exp $
 //
 //  Usage: Functions and stuff for Configure class, holding and
 //           reading config stuff.
@@ -8,20 +8,20 @@
 //    LICENSE for complete information.                                         
 /////////////////////////////////////////////////////////////////////
 
-#define __CONFIGURATION_CPP__
+#define CONFIGURATION_CPP
 
 #include "Configuration.h"
 
+class Configuration *config;
+
 Configuration::Configuration()
 {
   conf_file = "babyftpd.conf";
   parsed = false;
 
-  general.id = "general";
   general.connection_limit = INT_MAX; // ain't this a bit high?
   general.port = 21; // default port
-  general.default_type = 0;
-  general.verbose = 1;
+  general.data_port = 20; // default outgoing data port
   general.no_daemon = false; // daemon mode or not?
   general.os = "UNIX"; // what OS is this?
   general.admin_email = ""; // admin email?
@@ -33,13 +33,15 @@ Configuration::Configuration()
   general.welcome_msg += " Server [";
   general.welcome_msg += tmp;
   general.welcome_msg += "]";
+  general.user = 0; // by default when run all as root
+  general.group = 0;
 #ifdef USE_TLS
-  general.tls_key = "/root/tls_key.pem";
-  general.tls_cert = "/root/tls_cert.pem";
-  general.tls_ca = "/root/tls_ca.pem";
-  general.tls_crl = "/root/tls_crl.pem";
+  general.tls_key = "/etc/babyftpd/tls_key.pem";
+  general.tls_cert = "/etc/babyftpd/tls_cert.pem";
+  general.tls_ca = "/etc/babyftpd/tls_ca.pem";
+  general.tls_crl = "/etc/babyftpd/tls_crl.pem";
   general.dh_regenerate = 3600; // seconds between diffie-hellman regenerations
-  general.user = 0; // by default when run all as root
+  general.verify_client = "/etc/babyftpd/verify_client.pl";
 
   general_user.encryption = ALLOW;
 #endif
@@ -47,15 +49,17 @@ Configuration::Configuration()
   logger.xferlog = true; // by default all transfers are logged
   logger.xferlog_file = "/var/log/xferlog"; // here
   logger.thread_id = false; // we don't want thread ids all over the logs
+  logger.time_format = "%b %e %H:%M:%S "; // time format
 
-  // these options end up as default for all users, that is, those that don't occur in the conf file get these values
+  // these options end up as default for all users, that is,
+  //  those that don't occur in the conf file get these values
   general_user.id = "user_general";
   general_user.sim_data = INT_MAX;
   general_user.idle = 900; // idle timeout after how long?
   general_user.noftp = 0; // can this user login with ftp or not?
-  general_user.only_home = 0; // can the user traverse anything but his/her homedir
-  general_user.only_passive = 0; // is the user limited to passive data transfers?
-  general_user.user_limit = INT_MAX; // maximum control connections from this user
+  general_user.only_home = 0; // false chroot in homedir?
+  general_user.only_passive = 0;
+  general_user.user_limit = INT_MAX; // maximum control connections
 }
 
 Configuration::~Configuration()
@@ -65,16 +69,12 @@ Configuration::~Configuration()
 bool Configuration::parse_config_file()
 {
   vector<string> file_buff;
-  fill_buff(file_buff, conf_file);
-
-  string Sgeneral = get_variables(file_buff, "general", 1);
-  set_general(Sgeneral);
-
-  string Suser = get_variables(file_buff, "general", 2);
-  general_user = set_users(Suser);
+  if(!fill_buff(file_buff, conf_file))
+    return(false);
 
-  string Slog = get_variables(file_buff, "log", 1);
-  set_logger(Slog);
+  set_structs(get_variables(file_buff, "general", 1), GENERAL, &general);
+  set_structs(get_variables(file_buff, "general", 2), USER, &general_user);
+  set_structs(get_variables(file_buff, "log", 1), LOG, &logger);
 
   string user_names;
   num_users = count_users(file_buff, user_names) - 1; // first user is 0.
@@ -82,11 +82,16 @@ bool Configuration::parse_config_file()
   class StringTokenizer *names = new StringTokenizer(user_names, ",", false);
   names->nextToken(); // not nice, but nicer.
 
+  if(!users.empty()) // that is, on SIGHUP
+    users.clear();
+
   users.reserve(num_users + 1);
   for(int i = 0; i < num_users; i++)
   {
-    string Susers = get_variables(file_buff, names->nextToken().c_str(), 2);
-    users.push_back(set_users(Susers));
+    struct users_stru user_tmp = general_user;
+    set_structs(get_variables(file_buff, names->nextToken().c_str(), 2),
+        USER, &user_tmp);
+    users.push_back(user_tmp);
   }
 
   parsed = true;
@@ -94,67 +99,287 @@ bool Configuration::parse_config_file()
   return true;
 }
 
-struct users_stru Configuration::set_users(string variables)
+bool Configuration::set_structs(string variables, int section, void *this_struct)
 {
-  struct users_stru usr = general_user;
+  struct users_stru *usr_tmp = NULL;
+  struct general_stru *gen_tmp = NULL;
+  struct log_stru *log_tmp = NULL;
+  vector<config_entry> this_entry;
+  string for_log = "Configuration for ";
+
+  switch(section)
+  {
+    case USER:
+      {
+        usr_tmp = (static_cast<struct users_stru*>(this_struct));
+
+        this_entry.push_back(config_entry(
+              "id", CONF_STRING, &usr_tmp->id));
+        this_entry.push_back(config_entry(
+              "sim_data", CONF_INT, &usr_tmp->sim_data));
+        this_entry.push_back(config_entry(
+              "idle", CONF_TIME, &usr_tmp->idle));
+        this_entry.push_back(config_entry(
+              "noftp", CONF_BOOL, &usr_tmp->noftp));
+        this_entry.push_back(config_entry(
+              "only_home", CONF_BOOL, &usr_tmp->only_home));
+        this_entry.push_back(config_entry(
+              "only_passive", CONF_BOOL, &usr_tmp->only_passive));
+        this_entry.push_back(config_entry(
+              "user_limit", CONF_INT, &usr_tmp->user_limit));
+#ifdef USE_TLS
+        this_entry.push_back(config_entry(
+              "encryption", CONF_ENC, &usr_tmp->encryption));
+#endif // USE_TLS
+        for_log += "user section ";
+      }
+      break;
 
+    case LOG:
+
+      {
+        log_tmp = (static_cast<struct log_stru*>(this_struct));
+
+        this_entry.push_back(config_entry(
+              "log_level", CONF_INT, &log_tmp->log_level));
+        this_entry.push_back(config_entry(
+              "xferlog", CONF_BOOL, &log_tmp->xferlog));
+        this_entry.push_back(config_entry(
+              "xferlog_file", CONF_LOGF, &log_tmp->xferlog_file));
+        this_entry.push_back(config_entry(
+              "authlog", CONF_LOGF, &log_tmp->authlog));
+        this_entry.push_back(config_entry(
+              "infolog", CONF_LOGF, &log_tmp->infolog));
+        this_entry.push_back(config_entry(
+              "debuglog", CONF_LOGF, &log_tmp->debuglog));
+        this_entry.push_back(config_entry(
+              "thread_id", CONF_BOOL, &log_tmp->thread_id));
+        this_entry.push_back(config_entry(
+              "time_format", CONF_TIMEF, &log_tmp->time_format));
+        for_log += "log section ";
+      }
+      break;
+
+    case GENERAL:
+      {
+        gen_tmp = (static_cast<struct general_stru*>(this_struct));
+
+        this_entry.push_back(config_entry(
+              "connection_limit", CONF_INT, &gen_tmp->connection_limit));
+        this_entry.push_back(config_entry(
+              "port", CONF_INT, &gen_tmp->port));
+        this_entry.push_back(config_entry(
+              "data_port", CONF_INT, &gen_tmp->data_port));
+        this_entry.push_back(config_entry(
+              "no_daemon", CONF_BOOL, &gen_tmp->no_daemon));
+        this_entry.push_back(config_entry(
+              "admin_email", CONF_STRING, &gen_tmp->admin_email));
+        this_entry.push_back(config_entry(
+              "welcome_msg", CONF_STRING, &gen_tmp->welcome_msg));
+        this_entry.push_back(config_entry(
+              "lifebeat_tick", CONF_TIME, &gen_tmp->lifebeat_tick));
+        this_entry.push_back(config_entry(
+              "user", CONF_USER, NULL));
+#ifdef USE_TLS
+        this_entry.push_back(config_entry(
+              "tls_key", CONF_STRING, &gen_tmp->tls_key));
+        this_entry.push_back(config_entry(
+              "tls_cert", CONF_STRING, &gen_tmp->tls_cert));
+        this_entry.push_back(config_entry(
+              "tls_ca", CONF_STRING, &gen_tmp->tls_ca));
+        this_entry.push_back(config_entry(
+              "tls_crl", CONF_STRING, &gen_tmp->tls_crl));
+        this_entry.push_back(config_entry(
+              "dh_regenerate", CONF_TIME, &gen_tmp->dh_regenerate));
+        this_entry.push_back(config_entry(
+              "verify_client", CONF_STRING, &gen_tmp->verify_client));
+#endif // USE_TLS
+        for_log += "general section ";
+      }
+      break;
+  }
   class StringTokenizer *var = new StringTokenizer(variables, "\n", false);
-  usr.id = var->nextToken();
+  string id = var->nextToken();
+  if(section == USER)
+  {
+    *(string*)this_entry[0].variabel = id;
+    for_log += "for " + id + " ";
+  }
 
-  while(var->countTokens() != 0)
+  while(var->hasMoreTokens())
   {
-    string str = var->nextToken();
+    string log_me, str = var->nextToken();
     class StringTokenizer *st = new StringTokenizer(str, " ", false);
     string op = st->nextToken();
-    string arg = st->nextToken();
-    if(op == users_op[0])
-      usr.sim_data = atoi(arg.c_str());
-    else if(op == users_op[1])
-      usr.idle = atoi(arg.c_str());
-    else if(op == users_op[2])
-      usr.noftp = atoi(arg.c_str());
-    else if(op == users_op[3])
-      usr.only_home = atoi(arg.c_str());
-    else if(op == users_op[4])
-      usr.only_passive = atoi(arg.c_str());
-    else if(op == users_op[5])
-      usr.user_limit = atoi(arg.c_str());
+    string arg = st->restTokens();
+    vector<config_entry>::iterator this_it = this_entry.begin();
+
+    for(; this_it != this_entry.end(); this_it++)
+      if(op == (*this_it).name)
+        break;
+
+    if(this_it == this_entry.end())
+      log_me = "Parameter " + op + " doesn't exist, check your spelling.";
+    else
+    {
+      switch((*this_it).type)
+      {
+        case CONF_TIME:
 #ifdef USE_TLS
-    else if(op == users_op[6])
+        case CONF_ENC:
+          if((*this_it).type == CONF_ENC)
     {
       if(arg == "allow")
-        usr.encryption = ALLOW;
+              arg = util.itos(ALLOW);
       else if(arg == "deny")
-        usr.encryption = DENY;
+              arg = util.itos(DENY);
       else if(arg == "force")
-        usr.encryption = FORCE;
+              arg = util.itos(FORCE);
+            else if(arg == "force_cert")
+              arg = util.itos(FORCE_CERT);
+            else
+              log_me = "only allow, force, foce_cert and deny are legal "
+                "parameters to encryption, " + arg + " isn't one of them.";
     }
+          else
 #endif // USE_TLS
-    delete st;
+            if((*this_it).type == CONF_TIME)
+            {
+              int multi = 1;
+              string::iterator st_it = arg.begin();
+              for(; st_it != arg.end(); st_it++)
+              {
+                if(isdigit(*st_it) || isspace(*st_it))
+                  continue;
+                else
+                  break;
   }
-  delete var;
+              if(st_it != arg.end())
+              {
+                switch(*st_it)
+                {
+                  case 's':
+                    multi = 1;
+                    break;
+                  case 'm':
+                    multi = 60;
+                    break;
+                  case 'h':
+                    multi = 3600;
+                    break;
+                  case 'd':
+                    multi = 86400;
+                    break;
+                  default:
+                    log_me = "I don't understand your time unit \'";
+                    log_me += *st_it;
+                    log_me += "\' to paramater " + op + " I will ignore it.";
+                }
+                if(!log_me.empty())
+                  break;
 
-  string for_logging =
-     "user conf for: " + usr.id
-     + " sim_data=" + util.itos(usr.sim_data)
-     + " idle=" + util.itos(usr.idle)
-     + " noftp=" + util.itos(usr.noftp)
-     + " only_home=" + util.itos(usr.only_home)
-     + " only_passive=" + util.itos(usr.only_passive)
-     + " user_limit=" + util.itos(usr.user_limit)
-#ifdef USE_TLS
-     + " encryption=";
-  if(usr.encryption == ALLOW)
-    for_logging += "allow";
-  else if(usr.encryption == DENY)
-    for_logging += "deny";
-  else if(usr.encryption == FORCE)
-    for_logging += "force"
-#endif // USE_TLS
-     ;
-  logging->log_this(3, TYPE_INFO, for_logging);
+                arg.erase(st_it, arg.end());
+                int temp_num = atoi(arg.c_str()) * multi;
+                arg = util.itos(temp_num);
+              }
+            }
+        case CONF_INT:
+          {
+            int i_value = 0;
+            bool error = false;
+            for(string::iterator it = arg.begin(); it != arg.end(); it++)
+              if(!isdigit(*it))
+              {
+                error = true;
+                break;
+              }
+            if(!error)
+              i_value = atoi(arg.c_str());
+            else
+              if(log_me.empty())
+                log_me = "Non int value supplied to " + op +
+                  " value supplied was " + arg + ".";
+
+            if(log_me.empty())
+            {
+              *(static_cast<int*>((*this_it).variabel)) = i_value;
+              for_log += (*this_it).name + "=" + util.itos(i_value) + "; ";
+            }
+          }
+          break;
+
+        case CONF_BOOL:
+          {
+            bool b_value = true;
+            if(arg == "true" || arg == "t" || arg == "1" || arg == "y")
+              b_value = true;
+            else if(arg == "false" || arg == "f" || arg == "0" || arg == "n")
+              b_value = false;
+            else
+              log_me = arg + " not recognised as a boolean value supplied to "
+                + op + ".";
+
+            if(log_me.empty())
+            {
+              *(static_cast<bool*>((*this_it).variabel)) = b_value;
+              for_log += (*this_it).name + (b_value ? "=true; " : "=false; ");
+            }
+          }
+          break;
+
+        case CONF_USER:
+          {
+            struct passwd pwd, *pwd_ptr;
+            struct group grp, *grp_ptr;
+            char pwdata[PWBUF_SIZE], grpdata[PWBUF_SIZE];
+            int delim = arg.find_first_of(':');
+            getpwnam_r(arg.substr(0, delim).c_str(),
+                &pwd, pwdata, sizeof(pwdata), &pwd_ptr);
+            getgrnam_r(arg.substr(delim + 1).c_str(),
+                &grp, grpdata, sizeof(grpdata), &grp_ptr);
+            if(pwd_ptr == NULL)
+            {
+              log_me = "Tried to use nonexistent user " + arg.substr(0,
+                  delim) + " to run the daemon under. using root instead.";
+              pwd.pw_uid = 0;
+              grp.gr_gid = 0;
+            }
+            else if(grp_ptr == NULL)
+            {
+              log_me = "Tried to use nonexistent group " + arg.substr(delim +1)
+                + " to run the daemon under. using root instead.";
+              grp.gr_gid = 0;
+            }
+            general.user = pwd.pw_uid;
+            general.group = grp.gr_gid;
+            for_log += (*this_it).name + "=" +
+              util.itos(pwd.pw_uid) + ":" + util.itos(grp.gr_gid) + "; ";
+          }
+          break;
+
+        case CONF_LOGF:
+          if(arg == "syslog")
+            arg.clear();
+        case CONF_TIMEF:
+          if((*this_it).type == CONF_TIMEF)
+            arg += " ";
+        case CONF_STRING:
+          *(static_cast<string*>((*this_it).variabel)) = arg;
+          for_log += (*this_it).name + "=" + arg + "; ";
+          break;
 
-  return(usr);
+        default:
+          log_me = "Parameter " + op + " doesn't exist, check your spelling.";
+          break;
+      }
+    }
+    delete st;
+    if(!log_me.empty())
+      logging->log_this(2, TYPE_INFO, log_me);
+  }
+  logging->log_this(3, TYPE_INFO, for_log);
+  delete var;
+  return true;
 }
 
 struct users_stru &Configuration::get_user(string name)
@@ -171,7 +396,8 @@ int Configuration::count_users(vector<st
   int ant = 0;
   int deep = 1, curr_deep = 0;
   string name = "user", section = "";
-  for(vector<string>::iterator buff_it = buff.begin(); buff_it != buff.end(); buff_it++)
+  for(vector<string>::iterator buff_it = buff.begin(); buff_it != buff.end();
+      buff_it++)
   {
     if(*buff_it == "{")
     {
@@ -194,154 +420,14 @@ int Configuration::count_users(vector<st
   return ant;
 }
 
-bool Configuration::set_general(string variables)
-{
-  class StringTokenizer *var = new StringTokenizer(variables, "\n", false);
-  general.id = var->nextToken();
-
-  while(var->hasMoreTokens())
-  {
-    string str = var->nextToken();
-    class StringTokenizer *st = new StringTokenizer(str, " ", false);
-    string op = st->nextToken();
-    string arg = st->restTokens();
-    if(op == general_op[0])
-      general.connection_limit = atoi(arg.c_str());
-    else if(op == general_op[1])
-      general.port = atoi(arg.c_str());
-    else if(op == general_op[2])
-      general.default_type = atoi(arg.c_str());
-    else if(op == general_op[3])
-      general.no_daemon = atoi(arg.c_str());
-    else if(op == general_op[4])
-      general.verbose = atoi(arg.c_str());
-    else if(op == general_op[5])
-      general.admin_email = arg;
-    else if(op == general_op[6])
-      general.welcome_msg = arg;
-    else if(op == general_op[7])
-      general.lifebeat_tick = atoi(arg.c_str());
-    else if(op == general_op[8])
-    {
-      struct passwd *pwd = getpwnam(arg.c_str());
-      if(pwd == NULL)
-        general.user = 0;
-      else
-        general.user = pwd->pw_uid;
-    }
-#ifdef USE_TLS
-    else if(op == general_op[9])
-      general.tls_key = arg;
-    else if(op == general_op[10])
-      general.tls_cert = arg;
-    else if(op == general_op[11])
-      general.tls_ca = arg;
-    else if(op == general_op[12])
-      general.tls_crl = arg;
-    else if(op == general_op[13])
-      general.dh_regenerate = atoi(arg.c_str());
-#endif
-    delete st;
-  }
-  delete var;
-
-  string for_logging =
-    "general configuration: \
-    connection_limit=" + util.itos(general.connection_limit)
-    + " port=" + util.itos(general.port)
-    + " default_type=" + util.itos(general.default_type)
-    + " verbose=" + util.itos(general.verbose)
-    + " no_daemon=" + util.itos(general.no_daemon)
-    + " os=" + general.os
-    + " admin_email=" + general.admin_email
-    + " welcome_msg=" + general.welcome_msg
-    + " lifebeat_tick=" + util.itos(general.lifebeat_tick)
-    + " user=" + util.itos(general.user)
-#ifdef USE_TLS
-    + " tls_key=" + general.tls_key
-    + " tls_cert=" + general.tls_cert
-    + " tls_ca=" + general.tls_ca
-    + " tls_crl=" + general.tls_crl
-    + " dh_regenerate=" + util.itos(general.dh_regenerate)
-#endif // USE_TLS
-    ;
-  logging->log_this(3, TYPE_INFO, for_logging);
-
-  return(true);
-}
-
-bool Configuration::set_logger(string variables)
-{
-  class StringTokenizer *var = new StringTokenizer(variables, "\n", false);
-
-  while(var->hasMoreTokens())
-  {
-    string str = var->nextToken();
-    class StringTokenizer *st = new StringTokenizer(str, " ", false);
-    string op = st->nextToken();
-    string arg = st->restTokens();
-    if(op == log_op[0])
-      logger.log_level = atoi(arg.c_str());
-    else if(op == log_op[1])
-    {
-      if(!(atoi(arg.c_str())))
-        logger.xferlog = false;
-    }
-
-    else if(op == log_op[2])
-      logger.xferlog_file = arg;
-
-    else if(op == log_op[3])
-    {
-      if(arg != "syslog")
-        logger.authlog = arg;
-    }
-
-    else if(op == log_op[4])
-    {
-      if(arg != "syslog")
-        logger.infolog = arg;
-    }
-
-    else if(op == log_op[5])
-    {
-      if(arg != "syslog")
-        logger.debuglog = arg;
-    }
-
-    else if(op == log_op[6])
-    {
-      if((atoi(arg.c_str())))
-        logger.thread_id = true;
-    }
-
-    delete st;
-  }
-  delete var;
-
-  string for_logging =
-    "logging configuration: \
-    log_level=" + util.itos(logger.log_level)
-    + " xferlog_enable=" + util.itos(logger.xferlog)
-    + " xferlog_file=" + logger.xferlog_file + " "
-    + log_op[3] + (logger.authlog.empty() ?
-        "=syslog " : "=" + logger.authlog + " ")
-    + log_op[4] + (logger.infolog.empty() ?
-        "=syslog " : "=" + logger.infolog + " ")
-    + log_op[5] + (logger.debuglog.empty() ?
-        "=syslog " : "=" + logger.debuglog)
-    + " thread_id=" + util.itos(logger.thread_id)
-    ;
-  logging->log_this(3, TYPE_INFO, for_logging);
 
-  return(true);
-}
-
-string Configuration::get_variables(vector<string> &buff, const char *key, int deep)
+string Configuration::get_variables(vector<string> &buff, const char *key,
+    int deep)
 {
   int curr_deep = 0;
   string section, str;
-  for(vector<string>::iterator buff_it = buff.begin(); buff_it != buff.end(); buff_it++)
+  for(vector<string>::iterator buff_it = buff.begin(); buff_it != buff.end();
+      buff_it++)
   {
     if((*buff_it).empty())
       continue;
@@ -361,13 +447,13 @@ string Configuration::get_variables(vect
         break;
       curr_deep--;
     }
-    else if(curr_deep == deep && section == key && *(buff_it + 1) != "{")
+    else if(curr_deep == deep && section == key)
       str += *buff_it + "\n";
   }
   return(str);
 }
 
-void Configuration::fill_buff(vector<string> &buff, string filename)
+bool Configuration::fill_buff(vector<string> &buff, string filename)
 {
   ifstream fin;
   fin.open(filename.c_str(), ifstream::in);
@@ -383,4 +469,77 @@ void Configuration::fill_buff(vector<str
   }
 
   fin.close();
+  if(buff.empty())
+    return(false);
+  else
+    return(true);
 }
+
+
+bool Configuration::parse_command_line(int argc, char **argv)
+{
+  int opt = 0;
+  const char *cmdopts = "hc:nVl:p:";
+
+  // struct for the long options... neat, huh?
+  struct option longopts[] =
+  {
+    { "help",      0, 0, 'h' },
+    { "conf-file", 1, 0, 'c' },
+    { "no-daemon", 0, 0, 'd' },
+    { "version",   0, 0, 'V' },
+    { "log-level", 1, 0, 'l' },
+    { "port",      1, 0, 'p' },
+    { 0,           0, 0, 0   }
+  };
+
+  while((opt = getopt_long(argc, argv, cmdopts, longopts, NULL)) != -1)
+  {
+    switch(opt)
+    {
+      case 'h':
+        cout << "Usage: " << argv[0] << " [OPTION]...\n\n"
+          << "  -h, --help            display this help and exit\n"
+          << "  -c, --conf-file=FILE  supply another conf file instead "
+          << "of the default\n"
+          << "  -n, --no-daemon       do not fork into the background\n"
+          << "  -V, --version         display version information and exit\n"
+          << "  -l, --log-level=LEVEL set the log level, 1-10, default is 5\n"
+          << "  -p, --port=PORT       specify an alternate port\n\n"
+          << "Please, report bugs, either directly to the developers\n"
+          << "or via sourceforge (http://www.sf.net/projects/babyftpd).\n";
+
+          exit_baby(0, EXIT_EARLY);
+
+      case 'c':
+        config->conf_file = optarg;
+        break;
+
+      case 'n':
+        config->general.no_daemon = true;
+        break;
+
+      case 'V':
+        cout << "BabyFTPd version " << VERSION << "\nBuilt on " << __DATE__
+          << " " << " " << __TIME__ << endl;
+        exit_baby(0, EXIT_EARLY);
+
+      case 'l':
+        // Log level code...
+        if(atoi(optarg) > 10)
+          logger.log_level = 10;
+        else if(atoi(optarg) < 0)
+          logger.log_level = 0;
+        else
+          logger.log_level = atoi(optarg);
+        break;
+
+      case 'p':
+        // alternate port...
+        config->general.port = atoi(optarg);
+        break;
+    }
+  }
+  return true;
+}
+
Index: Configuration.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Configuration.h,v
retrieving revision 1.33
diff -u -p -b -r1.33 Configuration.h
--- Configuration.h	22 Jan 2005 23:06:05 -0000	1.33
+++ Configuration.h	10 Apr 2005 22:43:19 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-//  $Id: Configuration.h,v 1.33 2005/01/22 23:06:05 klas Exp $
+//  $Id: Configuration.h,v 1.50 2005/03/28 17:06:44 klas Exp $
 //
 //  Usage: Configure class, reading the config file and holding
 //           configurish variables.
@@ -9,14 +9,16 @@
 /////////////////////////////////////////////////////////////////////
 
 
-#ifndef __CONFIGURATION_H__
-#define __CONFIGURATION_H__
+#ifndef CONFIGURATION_H
+#define CONFIGURATION_H
 
-#ifdef __CONFIGURATION_CPP__
+#ifdef CONFIGURATION_CPP
 #include "generic.h"
 #include "StringTokenizer.h"
 #include "Utilities.h"
 #include "Log.h"
+extern void exit_baby(int, int);
+const char *VERSION = "CVS: "__DATE__; // remember to change on release.
 #endif
 
 struct log_stru
@@ -28,6 +30,7 @@ struct log_stru
   string infolog;
   string debuglog;
   bool thread_id;
+  string time_format;
 };
 
 struct users_stru
@@ -35,7 +38,7 @@ struct users_stru
   string id;
   int sim_data;
   int idle;
-  int noftp;
+  bool noftp;
   int only_home;
   int only_passive;
   int user_limit;
@@ -46,23 +49,23 @@ struct users_stru
 
 struct general_stru
 {
-  string id;
   int connection_limit;
   int port;
-  int default_type;
-  int verbose;
+  int data_port;
   bool no_daemon;
   string os;
   string admin_email;
   string welcome_msg;
   int lifebeat_tick;
   uid_t user;
+  gid_t group;
 #ifdef USE_TLS  
   string tls_key;
   string tls_cert;
   string tls_ca;
   string tls_crl;
   int dh_regenerate;
+  string verify_client;
 #endif
 };
 
@@ -73,13 +76,12 @@ class Configuration
     int num_users;
     bool parsed;
     int count_users(vector<string>, string&);
-    void fill_buff(vector<string>&, string);
+    bool fill_buff(vector<string>&, string);
     string get_variables(vector<string>&, const char*, int);
-    bool set_general(string variables);
-    struct users_stru set_users(string);
-    bool set_logger(string variables);
+    bool set_structs(string, int, void*);
   public:
     bool parse_config_file();
+    bool parse_command_line(int argc, char **argv);
     string conf_file;
     struct log_stru logger;
     struct general_stru general;
@@ -89,63 +91,41 @@ class Configuration
     ~Configuration(void);
 };
 
-#ifdef USE_TLS
-const string general_op[14] =
-#else
-const string general_op[9] =
-#endif // USE_TLS
-{
-  "connection_limit",
-  "port",
-  "default:type",
-  "no_daemon",
-  "verbose",
-  "admin_email",
-  "welcome_msg",
-  "lifebeat_tick",
-  "user"
-#ifdef USE_TLS
-  ,"tls_key",
-  "tls_cert",
-  "tls_ca",
-  "tls_crl",
-  "dh_regenerate"
-#endif
-};
+extern class Configuration *config;
 
-const string log_op[7] =
+struct config_entry
 {
-  "log_level",
-  "xferlog",
-  "xferlog_file",
-  "authlog",
-  "infolog",
-  "debuglog",
-  "thread_id"
-};
-
-#ifdef USE_TLS
-const string users_op[7] =
-#else
-const string users_op[6] =
-#endif // USE_TLS
-{
-  "sim_data",
-  "idle",
-  "noftp",
-  "only_home",
-  "only_passive",
-  "user_limit"
-#ifdef USE_TLS
-  ,"encryption"
+  string name;
+  int type;
+  void *variabel;
+  config_entry(const string t_name, const int t_type, void *t_vari)
+  {
+    name = t_name;
+    type = t_type;
+    variabel = t_vari;
+  }
+};
+
+typedef struct config_entry config_entry;
+
+const int CONF_INT = 1;
+const int CONF_BOOL = 2;
+const int CONF_STRING = 3;
+const int CONF_LOGF = 4;
+const int CONF_ENC = 5;
+const int CONF_USER = 6;
+const int CONF_TIMEF = 7;
+const int CONF_TIME = 8;
+
+const int USER = 1;
+const int LOG = 2;
+const int GENERAL = 3;
+
+#ifdef USE_TLS
+const int ALLOW = 1;
+const int FORCE = 2;
+const int DENY = 3;
+const int FORCE_CERT = 4;
 #endif // USE_TLS
-};
-
-extern class Utilities util;
 
-#ifdef USE_TLS
-#define ALLOW 1
-#define FORCE 2
-#define DENY 3
-#endif // USE_TLS
 #endif
